Subject: Re: [SCITT] [EXT]Re: Endor: A SCITT PoC for W3C Verifiable Credentials

From: "Dick Brooks" <[email-masked]>
Date: Tue, 16 Aug 2022 08:51:28 -0400

+1 to Carl’s statement: “[CW] OK. But ACME still needs to get its bearings to trust the signature from Wabbit Networks. There may be compliance programs where a digital letter of approval is generated as well, in which case ACME Rockets need not be the authority.”

IMO, SCITT provide the opportunity to provide customers with the ability to verify the authorized trust relationship between an artifact owner and an artifact signer. 

We currently use the SHA256 Hash value of an artifact and the X.509 Thumbprint or PGP fingerprint of the digital signature to search for trust declarations in SAG-CTR.

Thanks,

Dick Brooks

Active Member of the CISA Critical Manufacturing Sector, 

Sector Coordinating Council – A Public-Private Partnership

 <https://reliableenergyanalytics.com/products> Never trust software, always verify and report! ™

 <http://www.reliableenergyanalytics.com/> http://www.reliableenergyanalytics.com

Email:  <mailto:[email-masked]> [email-masked]

Tel: +1 978-696-1788

From: Carl Wallace <[email-masked]> 
Sent: Tuesday, August 16, 2022 7:10 AM
To: Steve Lasker <[email-masked]>; [email-masked]; Orie Steele <[email-masked]>
Cc: [email-masked]
Subject: Re: [SCITT] [EXT]Re: Endor: A SCITT PoC for W3C Verifiable Credentials

Inline…

From: Steve Lasker <[email-masked] <mailto:[email-masked]> >
Date: Monday, August 15, 2022 at 12:25 PM
To: Carl Wallace <[email-masked] <mailto:[email-masked]> >, "[email-masked] <mailto:[email-masked]> " <[email-masked] <mailto:[email-masked]> >, Orie Steele <[email-masked] <mailto:[email-masked]> >
Cc: "[email-masked] <mailto:[email-masked]> " <[email-masked] <mailto:[email-masked]> >
Subject: RE: [SCITT] [EXT]Re: Endor: A SCITT PoC for W3C Verifiable Credentials

Thanks Carl,

*	The code signing example has cropped up here fairly often (i.e., why should my code signing key be accepted as fit to verify a signature on some other company’s code). 

Parsing this a bit more. I believe we’re talking about the promotion scenario. Where entity B consumes artifacts from Entity A. In the Notary v2 scenarios, we talk about Wabbit Networks as an ISV, and ACME Rockets as a consumer of the software.

When ACME Rockets consumes the net-monitor:v1 software from the Wabbit Networks public endpoint, how do services within ACME rockets know the artifact was approved for internal usage? 

[CW] Thank you for the example as this clearly illustrates we are talking about different things. In your example, how does ACME rockets know the artifact is a genuine product of Wabbit Networks? Current code signing mechanisms don’t achieve this (as Dick has noted). Ideally, public keys would not be trusted for a broader context than is actually necessary.

One solution is simply adding an ACME Rockets signature to the net-monitor:v1 software. Then, internal systems only need to check if an ACME Rockets signature exists, and it would be approved. This is overly simplistic. With SCITT, we can now add “context” to what scenarios/environments the net-monitor:v1 software was approved for use within ACME Rockets. 

The premise is consumers within ACME Rockets check for a specific claim/attestation/endorsement to allow the artifact to pass a check. However, the filter on the claims check is based on a set of approved identities. For instance, if Wabbit Networks says it passes ABC123 compliance, that’s nice, but it wouldn’t pass the check. Only claims from ACME Rockets for ABC123 compliance would be allowed to pass. 

So, the identity is a pre-filter to a set of claims/attestations/endorsements. 

[CW] OK. But ACME still needs to get its bearings to trust the signature from Wabbit Networks. There may be compliance programs where a digital letter of approval is generated as well, in which case ACME Rockets need not be the authority.

------

*	We’ll need a means to correlate the multiples, as how do they merge.
*	[CW] I’m not following why we would merge collections. Selecting a collection for use seems more likely.

How would we support a company that has multiple trusts policies they need to support? There may be a company wide policy, and a department specific policy. Or, there may be an industry policy and a company specific policy. When additive, these are easy. When overlapping, how do we define the resolution of conflicting deny/accept policies?

[CW] Each of these polices describing what is fit for internal use may require proof of origin, integrity, etc. before the ACME Rockets’ signature is applied. A goal of the spec I referenced is representation of trust anchors along with constraints on usage. These constraints would apply to CAs and end entities, if any, and be used by relying parties. In this case, the component that applies the ACME signature would be a relying party. ACME Rockets doesn’t get to choose what key Wabbit Networks used to sign something, but can enforce constraints on the usage of public keys to limit damage if the corresponding private key is ever stolen (so that they don’t consume a net-monitor:v1 that purports to be from Wabbit Networks but was signed by Coyote, Inc.). Expressing/enforcing constraints is the hard part. The spec is loosely based on the FIDO metadata syntax, where authenticator values provide a clean target. At present it uses identifiers, claims, etc. from various specs related to the RATS working group, but is a work in progress.

From: Carl Wallace <[email-masked] <mailto:[email-masked]> > 
Sent: Friday, August 12, 2022 3:55 AM
To: Steve Lasker <[email-masked] <mailto:[email-masked]> >; [email-masked] <mailto:[email-masked]> ; Orie Steele <[email-masked] <mailto:[email-masked]> >
Cc: [email-masked] <mailto:[email-masked]> ; Steve Lasker <[email-masked] <mailto:[email-masked]> >
Subject: Re: [SCITT] [EXT]Re: Endor: A SCITT PoC for W3C Verifiable Credentials

Inline…

From: Steve Lasker <[email-masked] <mailto:[email-masked]> >
Date: Thursday, August 11, 2022 at 7:20 PM
To: "[email-masked] <mailto:[email-masked]> " <[email-masked] <mailto:[email-masked]> >, 'Carl Wallace' <[email-masked] <mailto:[email-masked]> >, Orie Steele <[email-masked] <mailto:[email-masked]> >
Cc: "[email-masked] <mailto:[email-masked]> " <[email-masked] <mailto:[email-masked]> >, 'Steve Lasker' <Steve.Lasker=[email-masked] <mailto:Steve.Lasker=[email-masked]> >
Subject: RE: [SCITT] [EXT]Re: Endor: A SCITT PoC for W3C Verifiable Credentials

Hi Carl, you bring up a great point that I should have clarified. 

There roots of trust should be a collection. 

[CW] My point was more that even where there is a collection and it is possible to (tightly) bound the scope of a trust anchor or any public key then we should. The code signing example has cropped up here fairly often (i.e., why should my code signing key be accepted as fit to verify a signature on some other company’s code). FIDO attestation roots suggest that at least in some cases per-company TAs/CAs are the norm. TAs/CAs could be constrained to codify that practice.

You may choose to have a “public/vertical” trust policy, and an internal team “trust policy”. 

We’ll need a means to correlate the multiples, as how do they merge.

[CW] I’m not following why we would merge collections. Selecting a collection for use seems more likely.

Dick – yup. It’s interesting to think about how a company stamps their security stamp, and how it relates to the sources they allow in. 

From: SCITT <[email-masked] <mailto:[email-masked]> > On Behalf Of Dick Brooks
Sent: Thursday, August 11, 2022 6:10 AM
To: 'Carl Wallace' <[email-masked] <mailto:[email-masked]> >; Orie Steele <[email-masked] <mailto:[email-masked]> >; Steve Lasker <[email-masked] <mailto:[email-masked]> >
Cc: [email-masked] <mailto:[email-masked]> ; 'Steve Lasker' <Steve.Lasker=[email-masked] <mailto:Steve.Lasker=[email-masked]> >
Subject: Re: [SCITT] [EXT]Re: Endor: A SCITT PoC for W3C Verifiable Credentials

Just like other entities in the sw supply chain, the entity providing the root of trust can impact the trustworthiness score of software. 

Thanks,

Dick Brooks

Active Member of the CISA Critical Manufacturing Sector, 

Sector Coordinating Council – A Public-Private Partnership

 <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Freliableenergyanalytics.com%2Fproducts&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911642646%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=zNsa%2F9hAM9Dv6Bs5cuQt1F08XNP27vOETxIUSze7ei8%3D&reserved=0> Never trust software, always verify and report! ™

 <https://nam06.safelinks.protection.outlook.com/?url=http%3A%2F%2Fwww.reliableenergyanalytics.com%2F&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911642646%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=SgRsOIxuC1uWCxvdXHQKtIoUiViTZsAmkbcUVbKg8Tc%3D&reserved=0> http://www.reliableenergyanalytics.com

Email:  <mailto:[email-masked]> [email-masked]

Tel: +1 978-696-1788

From: Carl Wallace <[email-masked] <mailto:[email-masked]> > 
Sent: Thursday, August 11, 2022 7:22 AM
To: Orie Steele <[email-masked] <mailto:[email-masked]> >; Steve Lasker <[email-masked] <mailto:[email-masked]> >
Cc: [email-masked] <mailto:[email-masked]> ; Steve Lasker <Steve.Lasker=[email-masked] <mailto:Steve.Lasker=[email-masked]> >; [email-masked] <mailto:[email-masked]> 
Subject: Re: [SCITT] [EXT]Re: Endor: A SCITT PoC for W3C Verifiable Credentials

A single “trust store” may or may not suffice, but we likely want to put some fences around each trust anchor to limit what the trust anchor may be used to verify.

The FIDO metadata alliance has method of organizing trust anchors based on authenticator type: https://fidoalliance.org/specs/mds/fido-metadata-statement-v3.0-ps-20210518.html <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Ffidoalliance.org%2Fspecs%2Fmds%2Ffido-metadata-statement-v3.0-ps-20210518.html&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911642646%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=Gj342RG0qKxw1odqST7YkFSxuRVujiJVYCQmKApPBQo%3D&reserved=0> .

I briefed this new spec to the RATS working group last month: https://datatracker.ietf.org/doc/html/draft-wallace-rats-concise-ta-stores-00 <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Fdraft-wallace-rats-concise-ta-stores-00&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911642646%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=VjMqFhx9tl6P42lYPa8aFS9T37%2Fx1Q3h3VMIS50MpzY%3D&reserved=0> . There’s a fork of the Veraison project’s Corim repo with support for the -00 draft added here: https://github.com/carl-wallace/corim <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Fgithub.com%2Fcarl-wallace%2Fcorim&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911642646%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=ehvyN0zu7lpCXiKqNJn33ZA5wJaMKBvT8Ohf9B2MLZA%3D&reserved=0> . I’d imagine the environment and constraints parts move a bit still, but the rough idea may be what you are getting at below.

From: SCITT <[email-masked] <mailto:[email-masked]> > on behalf of Orie Steele <[email-masked] <mailto:[email-masked]> >
Date: Wednesday, August 10, 2022 at 2:30 PM
To: Steve Lasker <[email-masked] <mailto:[email-masked]> >
Cc: "[email-masked] <mailto:[email-masked]> " <[email-masked] <mailto:[email-masked]> >, Steve Lasker <Steve.Lasker=[email-masked]>, "[email-masked] <mailto:[email-masked]> " <[email-masked] <mailto:[email-masked]> >
Subject: Re: [SCITT] [EXT]Re: Endor: A SCITT PoC for W3C Verifiable Credentials

> This just points to the value of having personal, company, industry policy based trust stores

+1 to this, here are a few examples of how groups have formed their own trust systems:

- https://www.iata.org/en/pressroom/pr/2020-12-16-01/ <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.iata.org%2Fen%2Fpressroom%2Fpr%2F2020-12-16-01%2F&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911642646%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=qlXcUZYepYKoL8mq3S24t326YjKfNxuyiQ1mCOCVNdo%3D&reserved=0>  (aviation / travel)
- https://vci.org/issuers <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Fvci.org%2Fissuers&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911642646%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=Plwdfa7YFE7N05Ir9PQGpoBfLOmX6qFX1rJ5X3fQwes%3D&reserved=0>  (healthcare)
- https://support.apple.com/guide/keychain-access/what-is-keychain-access-kyca1083/mac <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Fsupport.apple.com%2Fguide%2Fkeychain-access%2Fwhat-is-keychain-access-kyca1083%2Fmac&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911642646%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=8oFBGLPzK70NsvpuOlx22lYKTqmHiWxUc1gqCzpUZxs%3D&reserved=0>  (personal)

You can imagine scenarios where a more limited set of issuers  might be required, or cases where you really want to be very open.

Regards,

OS

On Wed, Aug 10, 2022 at 1:21 PM Steve Lasker <[email-masked] <mailto:[email-masked]> > wrote:

It’s an interesting example of whether a single root trust store is the best solution. 

Just because the browser trusts a root certificate, doesn’t mean it’s something we individually, or as a company believe is appropriate. We’ll just leave the specifics for obvious conclusion. 

This just points to the value of having personal, company, industry policy based trust stores

From: SCITT <[email-masked] <mailto:[email-masked]> > On Behalf Of Dick Brooks
Sent: Wednesday, August 3, 2022 11:26 AM
To: 'Hart, Charlie' <[email-masked] <mailto:[email-masked]> >; Orie Steele <[email-masked] <mailto:[email-masked]> >
Cc: 'Steve Lasker' <Steve.Lasker=[email-masked] <mailto:[email-masked]> >; [email-masked] <mailto:[email-masked]> 
Subject: Re: [SCITT] [EXT]Re: Endor: A SCITT PoC for W3C Verifiable Credentials

That’s correct, Charlie. OATI’s root cert is not included in the browser trusted certificate store. 

I’m not sure why they chose to do this. 

Thanks,

Dick Brooks

Active Member of the CISA Critical Manufacturing Sector, 

Sector Coordinating Council – A Public-Private Partnership

 <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Freliableenergyanalytics.com%2Fproducts&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911642646%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=zNsa%2F9hAM9Dv6Bs5cuQt1F08XNP27vOETxIUSze7ei8%3D&reserved=0> Never trust software, always verify and report! ™

 <https://nam06.safelinks.protection.outlook.com/?url=http%3A%2F%2Fwww.reliableenergyanalytics.com%2F&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911642646%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=SgRsOIxuC1uWCxvdXHQKtIoUiViTZsAmkbcUVbKg8Tc%3D&reserved=0> http://www.reliableenergyanalytics.com

Email:  <mailto:[email-masked]> [email-masked]

Tel: +1 978-696-1788

From: Hart, Charlie <[email-masked] <mailto:[email-masked]> > 
Sent: Wednesday, August 3, 2022 12:00 PM
To: 'Orie Steele' <[email-masked] <mailto:[email-masked]> >; [email-masked] <mailto:[email-masked]> 
Cc: 'Steve Lasker' <Steve.Lasker=[email-masked] <mailto:Steve.Lasker=[email-masked]> >; [email-masked] <mailto:[email-masked]> 
Subject: Re: [SCITT] [EXT]Re: Endor: A SCITT PoC for W3C Verifiable Credentials

(Side comment: I see that OATI is not a recognized root certificate authority by Mozilla or Apple - didn't check others - so the website is therefore inaccessible without relaxing security.)

  _____  

From: SCITT <[email-masked] <mailto:[email-masked]> > on behalf of Hart, Charlie <[email-masked] <mailto:[email-masked]> >
Sent: Wednesday, August 3, 2022 11:48 AM
To: 'Orie Steele' <[email-masked] <mailto:[email-masked]> >; [email-masked] <mailto:[email-masked]>  <[email-masked] <mailto:[email-masked]> >
Cc: 'Steve Lasker' <Steve.Lasker=[email-masked] <mailto:Steve.Lasker=[email-masked]> >; [email-masked] <mailto:[email-masked]>  <[email-masked] <mailto:[email-masked]> >
Subject: Re: [SCITT] [EXT]Re: Endor: A SCITT PoC for W3C Verifiable Credentials 

Thanks Dick. That is really helpful for SCITT a lot of related projects I am working on.

Charlie

  _____  

From: SCITT <[email-masked] <mailto:[email-masked]> > on behalf of Dick Brooks <[email-masked] <mailto:[email-masked]> >
Sent: Wednesday, August 3, 2022 9:26 AM
To: 'Orie Steele' <[email-masked] <mailto:[email-masked]> >
Cc: 'Steve Lasker' <Steve.Lasker=[email-masked] <mailto:Steve.Lasker=[email-masked]> >; [email-masked] <mailto:[email-masked]>  <[email-masked] <mailto:[email-masked]> >
Subject: [EXT]Re: [SCITT] Endor: A SCITT PoC for W3C Verifiable Credentials 

Orie,

Here is a high-level overview of the authentication mechanism and tracking used today for OASIS, inter-tie electricity scheduling.

Everything starts with the NAESB registry (EIR); https://www.naesb.org/pdf4/webregistry_mo_registration_quick_ref_guide_v1.0_0417.pdf 

Entities involved in inter-tie electricity transactions must register with NAESB’s EIR, see link above.

The registration process requires a party to obtain a NAESB compliant X.509 certificate from an accredited certificate authority (ACA); https://www.naesb.org/pdf4/ac_authorities_2022.pdf

Entities use their digital certificates for identification in OASIS; https://www.naesbwry.oati.com/NAESBWRY/sys-index.wml 

Inter-tie transactions are scheduled and tracked, using an E-TAG; https://en.wikipedia.org/wiki/NERC_Tag 

E-TAG’s are used to “connect the dots” and settle transactions that flow across Balancing Authroities.

Hope this helps.

Thanks,

Dick Brooks

Active Member of the CISA Critical Manufacturing Sector, 

Sector Coordinating Council – A Public-Private Partnership

Never trust software, always verify and report! ™

http://www.reliableenergyanalytics.com

Email:  <mailto:[email-masked]> [email-masked]

Tel: +1 978-696-1788

From: Orie Steele <[email-masked] <mailto:[email-masked]> > 
Sent: Wednesday, August 3, 2022 9:09 AM
To: dick <[email-masked] <mailto:[email-masked]> >
Cc: Steve Lasker <Steve.Lasker=[email-masked] <mailto:Steve.Lasker=[email-masked]> >; [email-masked] <mailto:[email-masked]> 
Subject: Re: [SCITT] Endor: A SCITT PoC for W3C Verifiable Credentials

Thanks! 

I am interested in applying Verifiable Credentials to energy use cases, even if we don't have customers in that sector today.

The calls are open (https://github.com/w3c-ccg/traceability-vocab#meetings), but fair warning that most of the work happens on github async, and we usually just process issues and PRs during call time.

There are also aspects of Verifiable Credentials that I believe are relevant to the structure of endorsements / receipts:

The concept of "evidence":

- https://www.w3.org/TR/vc-data-model/#evidence
- https://datatracker.ietf.org/doc/html/draft-ietf-cose-countersign#section-3.1
- https://datatracker.ietf.org/doc/html/rfc4998

As one example.

I am hopeful that the next version of the Verifiable Credentials specification can point more directly to IETF RFCs to make its arguments, 
even if the json data model can't be updated to support CBOR / COSE as a first class citizen this round.
Perhaps the next charter for that WG might support this better, if we pave the way with examples.

Regards,

OS

On Wed, Aug 3, 2022, 7:54 AM Dick Brooks <[email-masked] <mailto:[email-masked]> > wrote:

I agree. This paper by Orie, Michael, Brian and Mahmoud is very useful as guide for terminology and semantics.

I can provide the authors with a description of how we track electricity transactions for inter-tie scheduling, called OASIS a NAESB standard, if interested.

Thanks,

Dick Brooks

Active Member of the CISA Critical Manufacturing Sector, 

Sector Coordinating Council – A Public-Private Partnership

Never trust software, always verify and report! ™

http://www.reliableenergyanalytics.com

Email:  <mailto:[email-masked]> [email-masked]

Tel: +1 978-696-1788

From: SCITT <[email-masked] <mailto:[email-masked]> > On Behalf Of Steve Lasker
Sent: Tuesday, August 2, 2022 8:21 PM
To: Orie Steele <[email-masked] <mailto:[email-masked]> >; [email-masked] <mailto:[email-masked]> 
Subject: Re: [SCITT] Endor: A SCITT PoC for W3C Verifiable Credentials

Very cool, Orie. 

Love the sandbox experiments

From: SCITT <[email-masked] <mailto:[email-masked]> > On Behalf Of Orie Steele
Sent: Saturday, July 30, 2022 2:08 PM
To: [email-masked] <mailto:[email-masked]> 
Subject: [SCITT] Endor: A SCITT PoC for W3C Verifiable Credentials

I made this today:

https://github.com/OR13/endor

As it says in the readme, this is just a toy example I made up to experiment with.

The nice thing about endorsing W3C Verifiable Credentials is that they are already an abstraction that applies to "non software supply chain" use cases... 

For example, we model cyber physical supply chain flows using them:

https://w3id.org/eability

There are a number of organizations looking at oil and gas, steel, ecommerce, and agriculture supply chains.

Often they will share some common trade documents such as Bills of Lading or Commercial Invoices.

These are examples of "SCITT Artifact Types" which you might expect to see across various distinct supply chain use cases.

However, as is the case with Oil and Gas needing to account for fluid dynamics, and software needing to account for compilers, build servers and various source files, there are cases where you may need to model components of a supply chain with Verifiable Credentials that are highly specific to the use case.

If you can tolerate modeling in RDF, W3C Verifiable Credentials come with a built in abstract data model that integrates well with existing industry ontologies such as:

- https://www.ebi.ac.uk/chebi/
- https://qudt.org/

My main complaint against W3C Verifiable Credentials is the limitation to JSON representations, if we could represent RDF in CBOR, we would have the best of both worlds with the main remaining disadvantage being the namespace overhead inherent in RDF.

If you drop that, you will likely need some registry or algorithm process for handling collisions and interoperability, but there are various solutions to those problems.

If you feel I butchered any of the concepts or terminology, feel free to yell at me here or on github issues, as I said, I made this today, it's not reflective of actual SCITT architecture, it was just to explore the space.

Regards,

OS

-- 

ORIE STEELE

Chief Technical Officer

www.transmute.industries

-- 

ORIE STEELE

Chief Technical Officer

www.transmute.industries <https://nam06.safelinks.protection.outlook.com/?url=http%3A%2F%2Fwww.transmute.industries%2F&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911798817%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=u3IwJwSQ08N1G9rMKO1eObaeSrfYZDs3p3NVYON6vcc%3D&reserved=0> 

 <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.transmute.industries%2F&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911798817%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=BPj6FWzmoc2OE8blamt3RIN9XvcacS8lwBohNtwvP4o%3D&reserved=0> 

-- SCITT mailing list [email-masked] <mailto:[email-masked]>  https://www.ietf.org/mailman/listinfo/scitt <https://nam06.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fscitt&data=05%7C01%7CSteve.Lasker%40microsoft.com%7C6a888c172005466abf7708da7c51151d%7C72f988bf86f141af91ab2d7cd011db47%7C1%7C0%7C637958985911955039%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C2000%7C%7C%7C&sdata=Op2iUr3S9NzUR02FePfw2JppnPShnK3H7%2BD72sSBeXk%3D&reserved=0>